import { Injectable } from '@angular/core';
import { IItem } from '../models/item';
import { IItemTask } from '../models/itemTask';
import { HttpClient } from "@angular/common/http";
import { AppConfig } from "../shared/app.config";
import { Observable } from 'rxjs';
import { IMolliePaymentResponse } from '../models/mollie.payment.response';

@Injectable({
  providedIn: 'root',
})

export class MollieService {
    constructor(
        public httpClient: HttpClient,
        public appConfig: AppConfig) {
    }

    ApiEndpoint() {
        return this.appConfig.getConfig("apiEndPoint");
    }
    
    createMolliePayment(templatePackage: IItem, redirectUrl: string): Observable<IMolliePaymentResponse> {
        let payload = {
            "currency": "EUR",
            "amount": "100.00",
            "redirectUrl": redirectUrl,
            "itemCode": templatePackage.code,
            "locale": "nl_NL",
            "validity": templatePackage.data?.validity
          };
        return this.httpClient.post<IMolliePaymentResponse>(`${this.ApiEndpoint()}/api/v1/payments/create`, payload);
    } 
}